/*
 * defines.h
 *
 * Copyright (c) 2014 Kirill Kryukov
 *
 * This file is a part of the Nucleotide Sequence Clusterizer source code,
 * and may only be used, modified, and distributed under the terms of the
 * license, located in the file LICENSE.txt within this package.
 */

#ifndef CLUSTERIZER_DEFINES_H
#define CLUSTERIZER_DEFINES_H

#define PROGRAM_NAME      "Nucleotide Sequence Clusterizer"
#define EXECUTABLE_NAME   "nucleotide-sequence-clusterizer"
#define VERSION           "0.0.4"
#define RELEASE_DATE      "2014-07-22"
#define COPYRIGHT_YEARS   "2014"
#define COPYRIGHT_AUTHORS "Kirill Kryukov"

#define unit_t unsigned long long   /* Unit for storing barcodes in binary form (platform's largest native integer). */

#define BYTES_PER_UNIT sizeof(unit_t)                   /*  8 */
#define BP_PER_BYTE 4                                   /*  4 */
#define BP_PER_UNIT (BYTES_PER_UNIT * BP_PER_BYTE)      /* 32 */

#define INDEX_SHIFT ((BP_PER_UNIT - INDEX_DEPTH) * 2)   /* How much a barcode unit should be right-shifted to obtain index. */
#define N_VOLUMES (1 << (INDEX_DEPTH * 2))              /* Number of barcode volumes. */

#endif
